% Lösung der Übungsaufgabe 3.3

% Vorgaben (Aufgabenstellung)
R = 1e3;                  % Ohm
C = 1e-6;                 % F
U = 10*exp(j*30*pi/180);  % V (Argument: Grad -> Radiant)
f = 1000;                 % Hz
disp("Vorgaben");
disp(["  R  = ",num2str(R)," Ohm"]);
disp(["  C  = ",num2str(C*1e6)," uF"]);
disp(["  U  = (",num2str(U),") V"]);
disp([" |U| = ",num2str(abs(U))," V"]);
disp(["phiu = ",num2str(angle(U)*180/pi),"°"]);
disp(["  f  = ",num2str(f)," Hz"]);
disp(" ");

% Berechnung der Impedanz
Z = R+1/(j*2*pi*f*C);
disp("Impedanz");
disp(["  Z  = (",num2str(Z),") Ohm"]);
disp([" |Z| = ",num2str(abs(Z))," Ohm"]);
disp([" phi = ",num2str(angle(Z)*180/pi),"°"]);
disp(" ");

% Komplexe Amplituden der Spannungen an R und C
Ur = U*R/Z;
Uc = U*(1/(j*2*pi*f*C))/Z;
disp("Komplexe Amplituden der Spannungen an R und C");
disp([" Ur  = (",num2str(Ur),") V"]);
disp(["|Ur| = ",num2str(abs(Ur))," V"]);
disp(["phir = ",num2str(angle(Ur)*180/pi),"°"]);
disp([" Uc  = (",num2str(Uc),") V"]);
disp(["|Uc| = ",num2str(abs(Uc))," V"]);
disp(["phic = ",num2str(angle(Uc)*180/pi),"°"]);
disp(" ");

% Berechnung des Stromes
I = U/Z;
disp("Strom durch die Reihenschaltung");
disp(["  I  = (",num2str(I*1e3),") mA"]);
disp([" |I| = ",num2str(abs(I*1e3))," mA"]);
disp(["phii = ",num2str(angle(I)*180/pi),"°"]);
disp(" ");

% =========================================================
% Funktion zur grafischen Darstellung eines Zeigers 
function pX = makepointer(x,s)
x = x(:);
d = x*s./abs(x);
pX = [zeros(length(x),1),x,x-d*(1+j/2),x,x-d*(1-j/2)].';
endfunction
% =========================================================

% Erzeugung des Zeigers (Linie und Pfeilspitze)
Umax = 10; % V  (Skalierung des Zeigerdiagramms)
pUr = makepointer(Ur,Umax/20);
pUc = makepointer(Uc,Umax/20);

% Darstellung des Zeigerdiagramms
hFig1 = figure("Name","Zeigerdiagramm");
hPlot1 = plot(pUr,"r",pUc,"b");
axis([-Umax,Umax,-Umax,Umax]);
axis square;
grid on;
title("\\bf Zeigerdiagramm","FontSize",14);
xlabel("Re\\{U\\} / V","FontSize",12);
ylabel("Im\\{U\\} / V","FontSize",12);
legend(hPlot1,"U_R","U_C","location","southeastoutside");




