% Lösung der Übungsaufgabe 3.7

% Vorgaben (Aufgabenstellung)
U  = 12;      % V
I1 = 60e-3;   % A
I2 = 40e-3;   % A
f1 = 50;      % Hz
f2 = 100;     % Hz
disp("Vorgaben");
disp(["  U  = ",num2str(U)," V"]);
disp(["  I1 = ",num2str(I1*1e3)," mA"]);
disp(["  I2 = ",num2str(I2*1e3)," mA"]);
disp(["  f1  = ",num2str(f1)," Hz"]);
disp(["  f2  = ",num2str(f2)," Hz"]);
disp(" ");

% Scheinwiderstand der Spule
Z1 = U/I1;
Z2 = U/I2;
disp("Scheinwiderstand der Spule");
disp(["Z1 = ",num2str(Z1)," Ohm bei f1 = ",num2str(f1)," Hz"]);
disp(["Z2 = ",num2str(Z2)," Ohm bei f2 = ",num2str(f2)," Hz"]);
disp(" ");

% Parameter der Ersatzschaltung
R = sqrt((((f2*Z1)^2)-((f1*Z2)^2))/(f2^2-f1^2));
L = sqrt((Z2^2-Z1^2)/(f2^2-f1^2))/(2*pi);
disp("Parameter der Ersatzschaltung");
disp(["  R  = ",num2str(R)," Ohm"]);
disp(["  L  = ",num2str(L*1e3)," mH"]);
disp(" ");

% Reihenschaltung mit Kondensator
C = 1/(4*((pi*f1)^2)*L+2*pi*f1*sqrt(3*(R^2)+16*(pi*f1*L)^2));
disp("Reihenschaltung mit Kondensator");
disp(["  C  = ",num2str(C*1e6)," uF"]);
disp(" ");

% Strom durch Spule und Spannung über Kondensator
I = I1/2;
UC = I/(2*pi*f1*C);
disp("Strom durch Spule und Spannung über Kondensator");
disp(["  I  = ",num2str(I*1e3)," mA"]);
disp(["  UC = ",num2str(UC)," V"]);
disp(" ");

% Resonanzfrequenz
f0 = 1/(2*pi*sqrt(L*C));
disp("Resonanzfrequenz");
disp(["  f0  = ",num2str(f0)," Hz"]);
disp(" ");

% Impedanzen und Blindwiderstände
XL = 2*pi*f1*L;
XC = -1/(2*pi*f1*C);
Z  = R+j*(XL+XC);
ZRL = R+j*XL;

% =========================================================
% Funktion zur grafischen Darstellung eines Zeigers 
function pX = makepointer(x,s)
x = x(:);
d = x*s./abs(x);
pX = [zeros(length(x),1),x,x-d*(1+j/2),x,x-d*(1-j/2)].';
endfunction
% =========================================================

% Erzeugung der Zeiger (Linie und Pfeilspitze)
Zmax = 400; % Ohm  (Skalierung des Zeigerdiagramms der Impedanzen)
pR = makepointer(R,Zmax/20);
pXL = makepointer(j*XL,Zmax/20);
pXC = makepointer(j*XC,Zmax/20);
pZ = makepointer(Z,Zmax/20);
pZRL = makepointer(ZRL,Zmax/20);

% Darstellung des Zeigerdiagramms der Impedanzen
hFig1 = figure("Name","Zeigerdiagramm der Impedanzen");
hPlot1 = plot(pZRL,"k--",pZ,"k",pR,"r",(pXL-Zmax/100),"b",...
         (pXL(2)+pXC+Zmax/100),"g");
% Der Zeiger pXL wird leicht nach links versetzt, der Zeiger pXC wird
% leicht nach rechts versetzt und beginnt an der Zeigerspitze von pXL.  
axis([-Zmax,Zmax,-Zmax,Zmax]);
axis square;
grid on;
title("\\bf Zeigerdiagramm der Impedanzen","FontSize",14);
xlabel("Re\\{Z\\} / \\Omega","FontSize",12);
ylabel("Im\\{Z\\} / \\Omega","FontSize",12);
legend(hPlot1,"Z_{RL}","Z","R","X_L","X_C","location","southeastoutside");
