% Lösung der Übungsaufgabe 3.8

% Vorgaben (Aufgabenstellung)
UR = 4.2;     % V
UZ = 3.4;     % V
U  = 6.3;     % V
R  = 470;     % Ohm
f  = 50;      % Hz
disp("Vorgaben");
disp(["  UR  = ",num2str(UR)," V"]);
disp(["  UZ  = ",num2str(UZ)," V"]);
disp(["  U   = ",num2str(U)," V"]);
disp(["  f   = ",num2str(f)," Hz"]);
disp(" ");

% Scheinwiderstand der unbekannten Impedanz
Zx = UZ*R/UR;
disp("Scheinwiderstand der unbekannten Impedanz");
disp(["  Zx  = ",num2str(Zx)," Ohm"]);
disp(" ");

% Wirk- und Blindanteil der unbekannten Impedanz
Rx = R*(U^2-UZ^2-UR^2)/(2*UR^2);
Xx = sqrt(Zx^2-Rx^2);
disp("Unbekannte Impedanz");
disp(["  Rx  = ",num2str(Rx)," Ohm"]);
disp(["  Xx1 = +",num2str(Xx)," Ohm"]);
disp(["  Xx2 = -",num2str(Xx)," Ohm"]);
disp(" ");

% Realisierung durch Reihenschaltung von R1 und L1
R1 = Rx;
L1 = Xx/(2*pi*f);
disp("Reihenschaltung von R1 und L1");
disp(["  R1   = ",num2str(R1)," Ohm"]);
disp(["  L1   = ",num2str(L1)," H"]);
disp(" ");

% Realisierung durch Parallelschaltung von R2 und L2
R2 = 1/(real(1/(Rx+j*Xx)));
L2 = -1/(2*pi*f*imag(1/(Rx+j*Xx)));
disp("Parallelschaltung von R2 und L2");
disp(["  R2   = ",num2str(R2)," Ohm"]);
disp(["  L2   = ",num2str(L2)," H"]);
disp(" ");

% Realisierung durch Reihenschaltung von R3 und C3
R3 = Rx;
C3 = 1/(2*pi*f*Xx);
disp("Reihenschaltung von R3 und C3");
disp(["  R3   = ",num2str(R3)," Ohm"]);
disp(["  C3   = ",num2str(C3*1e6)," uF"]);
disp(" ");

% Realisierung durch Parallelschaltung von R4 und C4
R4 = 1/(real(1/(Rx+j*Xx)));
C4 = -imag(1/(Rx+j*Xx))/(2*pi*f);
disp("Parallelschaltung von R4 und C4");
disp(["  R4   = ",num2str(R4)," Ohm"]);
disp(["  C4   = ",num2str(C4*1e6)," uF"]);
disp(" ");

% Komplexe Spannungen (induktive Impedanz)
URi = UR*exp(j*0); % Festlegung der Bezugsphase
UZi = UR*(Rx+j*Xx)/R;
Ui = UR*(R+Rx+j*Xx)/R;
disp("Komplexe Spannungen an induktiver Impedanz");
disp(["   URi     = (",num2str(URi),") V"]);
disp(["  |URi|    = ",num2str(abs(URi))," V"]);
disp(["  arg(URi) = ",num2str(angle(URi)*180/pi)," Grad"]);
disp(["   UZi     = (",num2str(UZi),") V"]);
disp(["  |UZi|    = ",num2str(abs(UZi))," V"]);
disp(["  arg(UZi) = ",num2str(angle(UZi)*180/pi)," Grad"]);
disp(["   Ui      = (",num2str(Ui),") V"]);
disp(["  |Ui|     = ",num2str(abs(Ui))," V"]);
disp(["  arg(Ui)  = ",num2str(angle(Ui)*180/pi)," Grad"]);
disp(" ");

% Komplexe Spannungen (kapazitive Impedanz)
URc = UR*exp(j*0); % Festlegung der Bezugsphase
UZc = UR*(Rx-j*Xx)/R;
Uc = UR*(R+Rx-j*Xx)/R;
disp("Komplexe Spannungen an kapazitiver Impedanz");
disp(["   URc     = (",num2str(URc),") V"]);
disp(["  |URc|    = ",num2str(abs(URc))," V"]);
disp(["  arg(URc) = ",num2str(angle(URc)*180/pi)," Grad"]);
disp(["   UZc     = (",num2str(UZc),") V"]);
disp(["  |UZc|    = ",num2str(abs(UZc))," V"]);
disp(["  arg(UZc) = ",num2str(angle(UZc)*180/pi)," Grad"]);
disp(["   Uc      = (",num2str(Uc),") V"]);
disp(["  |Uc|     = ",num2str(abs(Uc))," V"]);
disp(["  arg(Uc)  = ",num2str(angle(Uc)*180/pi)," Grad"]);
disp(" ");

% =========================================================
% Funktion zur grafischen Darstellung eines Zeigers 
function pX = makepointer(x,s)
x = x(:);
d = x*s./abs(x);
pX = [zeros(length(x),1),x,x-d*(1+j/2),x,x-d*(1-j/2)].';
endfunction
% =========================================================

% Erzeugung der Zeiger (Linie und Pfeilspitze)
Umax = 6; % V  (Skalierung der Zeigerdiagramme)
pURi = makepointer(URi,Umax/20);
pUZi = makepointer(UZi,Umax/20);
pUi  = makepointer(Ui,Umax/20);
pURc = makepointer(URc,Umax/20);
pUZc = makepointer(UZc,Umax/20);
pUc  = makepointer(Uc,Umax/20);

% Darstellung des Zeigerdiagramms bei induktiver Impedanz
hFig1 = figure("Name","Zeigerdiagramm bei induktiver Impedanz");
hPlot1 = plot(pURi,"r",pUZi,"b",pUi,"k",(pURi(2)+pUZi),"b--");
axis([-Umax,Umax,-Umax,Umax]);
axis square;
grid on;
title("\\bf Zeigerdiagramm bei induktiver Impedanz","FontSize",14);
xlabel("Re\\{U\\} / V","FontSize",12);
ylabel("Im\\{U\\} / V","FontSize",12);
legend(hPlot1,"U_R","U_Z","U","location","southeastoutside");

% Darstellung des Zeigerdiagramms bei kapazitiver Impedanz
hFig2 = figure("Name","Zeigerdiagramm bei kapazitiver Impedanz");
hPlot2 = plot(pURc,"r",pUZc,"b",pUc,"k",(pURc(2)+pUZc),"b--");
axis([-Umax,Umax,-Umax,Umax]);
axis square;
grid on;
title("\\bf Zeigerdiagramm bei kapazitiver Impedanz","FontSize",14);
xlabel("Re\\{U\\} / V","FontSize",12);
ylabel("Im\\{U\\} / V","FontSize",12);
legend(hPlot2,"U_R","U_Z","U","location","southeastoutside");
