% Lösung der Übungsaufgabe 3.10

% Vorgaben (Aufgabenstellung)
alpha_min = 0; % Einstellbereich des
alpha_max = 1; % Potentiometers
r = [0.5,1,2]; % Widerstandsverhältnis R/RL

% Festlegung der Stützstellen
N = 200;
n = 0:(N-1);
alpha = n*(alpha_max-alpha_min)/(N-1)+alpha_min;

% Normierte Spannung (y = U/Uq)
y = zeros(length(alpha),length(r));
for i = 1:length(r)
  y(:,i) = alpha./(1+(1-alpha).*alpha*r(i));
endfor

% Darstellung der normierten Spannung
hFig1 = figure("Name","Normierte Spannung");
hPlot1 = [];
c = "rbk";
s = {"R/R_L = 1/2","R/R_L = 1","R/R_L = 2"};
hold on;
for i = 1:length(r)
  hPlot1 = [hPlot1,plot(y(:,i),alpha,c(i))];
endfor
hold off;
grid on;
legend(hPlot1,s,"location","southeast");
title("\\bf Normierte Spannung","FontSize",14);
xlabel("\\alpha ","FontSize",12);
ylabel("U(\\alpha) / U_q","FontSize",12);
