% Lösung der Übungsaufgabe 3.13

% Vorgaben (Aufgabenstellung)
R1 = 1e3;     % Ohm
R2 = 250;     % Ohm
R3 = 1e3;     % Ohm
R4 = 3e3;     % Ohm
U0 = 12;      % V
disp("Vorgaben");
disp(["  R1  = ",num2str(R1)," Ohm"]);
disp(["  R2  = ",num2str(R2)," Ohm"]);
disp(["  R3  = ",num2str(R3)," Ohm"]);
disp(["  R4  = ",num2str(R4)," Ohm"]);
disp(["  U0  = ",num2str(U0)," V"]);
disp(" ");

% Spannungen und Ströme
U1 = U0*R1/(R1+R2+R3*R4/(R3+R4));
U2 = U0*R2/(R1+R2+R3*R4/(R3+R4));
U3 = U0-U1-U2;
U4 = U3;
I1 = U1/R1;
I2 = U2/R2;
I3 = U3/R3;
I4 = U4/R4;
disp("Spannungen und Ströme");
disp(["  U1  = ",num2str(U1)," V"]);
disp(["  U2  = ",num2str(U2)," V"]);
disp(["  U3  = ",num2str(U3)," V"]);
disp(["  U4  = ",num2str(U4)," V"]);
disp(["  I1  = ",num2str(I1*1e3)," mA"]);
disp(["  I2  = ",num2str(I2*1e3)," mA"]);
disp(["  I3  = ",num2str(I3*1e3)," mA"]);
disp(["  I4  = ",num2str(I4*1e3)," mA"]);
disp(" ");

% Spannung und Strom an den Klemmen
U = U2+U3;
I = 0;
disp("Spannung und Strom an den Klemmen");
disp(["  U   = ",num2str(U)," V"]);
disp(["  I   = ",num2str(I*1e3)," mA"]);
disp(" ");

% Innenwiderstand
R0 = (R1*R2*R3+R1*R2*R4+R1*R3*R4)/(R1*R3+R1*R4+R2*R3+R2*R4+R3*R4);
disp("Innenwiderstand");
disp(["  R0  = ",num2str(R0)," Ohm"]);
disp(" ");

% Grenzen des Darstellungsbereichs
Rmin = 0;     % Ohm
Rmax = 5*R0;  % Ohm
Umin = 0;     % V
Umax = U0/2;  % V
Imin = 0;     % A
Imax = U0/(2*R0); % A

% Festlegung der Stützstellen
N = 200;
n = 0:(N-1);
R = n*(Rmax-Rmin)/(N-1)+Rmin;

% Spannung und Strom bei Variation des Lastwiderstands R
U = (U0/2)*R./(R+R0);
I = (U0/2)./(R+R0);

% Darstellung der Spannung
hFig1 = figure("Name","Spannung");
hPlot1 = plot(R*1e-3,U,"r"); % R in k Ohm
axis([Rmin*1e-3,Rmax*1e-3,Umin,Umax]);
grid on;
title("\\bf Spannung","FontSize",14);
xlabel("R / k\\Omega ","FontSize",12);
ylabel("U / V","FontSize",12);

% Darstellung des Stroms
hFig2 = figure("Name","Strom");
hPlot2 = plot(R*1e-3,I*1e3,"b"); % R in KOhm, I in mA
axis([Rmin*1e-3,Rmax*1e-3,Imin*1e3,Imax*1e3]);
grid on;
title("\\bf Strom","FontSize",14);
xlabel("R / k\\Omega ","FontSize",12);
ylabel("I / mA","FontSize",12);
